

class_and_method = """
class a:
    def foo():
        pass
"""

two_classes_with_same_named_method = """
class a:
    def foo():
        pass

class b:
    def foo():
        pass

"""

a_class_with_two_methods = """
class a:
    def foo():
        a=b
    def bah():
        pass
"""


source_with_all_ast_nodes = """
#from __future__ import yield
import foo
import sys
from a import b as c

def bah():
    pass

class x: pass
class y: pass

# comment
# comment b
class a:  # my comment
          # my second comment indented the same way
    # comment
    def foo(self):
        \"\"\" multi line doc string
        \"\"\"
        b = 3
        if a == 3:
            print "hello"  # this is a comment
            print >> sys.stderr, "this goes to stderr"
            if anifstatementSpreadOverMultipleLines and \\
               anotherone:
                pass
            elif a == 5:
                pass
        else:
            self.foo()            # a comment here
            e = self.bah()    # a comment indented differently
        class a(x, 
                y):
            def f(): a.b = c
        return b
    def bah(self):
        self.a = ladida  #foo()
        pass
    def DEBUG(self):
        print >> sys.stderr, "\tfrees:", self.frees
    def exception(self):
        exec \"print \\\"hello\\\"\"
        raise MyException

    #def yieldingFn(self):
    #    a = arse
    #    while (1):
    #        yield a + 1

    def tryexcept(self):
        try:
            self.exception()
        except MyException:
            pass
    def tryfinally(self):
        try:
            self.exception()
        finally:
            pass
    def delete(self, iter):
        del self[iter]

    def whilething(self, arg):
        while it != self.end:
            res+=str(it.deref())+","
            if a == 3:
                break
            if a == 2:
                continue

    def keywordargs(self, *args):
        pass

    def keywordclient(self):
        bah = self.keywordargs(a = foo)

    def formethod(self):
        global a
        for i in foo:
            pass
        a = 2
        b = not b
        self.whilething(a+1+3)
        self.whilething(a*1*3)
        a, b = 1, 2
        [a, b] = [1, 2]
        packagenames = [x.name for x in[y.foo for y in self.packages]]
        listcompiftest = [x.name for x in a if x.foo == 3]
        [s2 for s1 in qs.split('&')for s2 in s1.split(';')]
        assert bah != 2
        ((a+2)+3)+b
        (2*3)*hue*6
        return a+3

def foo():
    start[1]-1
    bah;
    return
"""


functionContaingObjectCreationAndMethodReferenceWithImport = """
import b.bah.TheClass
def foo():
    a = b.bah.TheClass()
    a.theMethod()
"""


ObjectCreationAndMethodReference = """
from b.bah import TheClass
a = TheClass()
a.theMethod()
"""

FunctionWithGetattr = """
def foo():
    a.b
"""

functionContaingObjectCreationAndMethodReferenceWithImportOfNestedClass = """
import b.bah.TheClass

def foo():
    a = b.bah.TheClass()
    a.theMethod()
"""

functionContaingObjectCreationAndMethodReferenceButNotImported = """
import b.bah.DifferentClass

def foo():
    a = b.bah.TheClass()
    a.theMethod()
"""


functionContaingObjectCreationAndMethodReferenceWithImportAs = """
import b.bah.TheClass as MyClass

def foo():
    a = MyClass()
    a.theMethod()
"""

functionContaingObjectCreationAndMethodReferenceWithImportFrom = """
from b.bah import TheClass

def foo():
    a = TheClass()
    a.theMethod()
"""

functionContaingObjectCreationAndMethodReferenceWithImportFromAs = """
from b.bah import TheClass as MyClass

def foo():
    a = MyClass()
    a.theMethod()
"""

FunctionContainingMethodReferenceButNotSameAsOneImported = """
from b.bah import TheClass as MyClass

def foo():
    a = TheClass()
    a.theMethod()
"""

FunctionContainingMethodReferenceWithFromImportStar = """
from b.bah import *
a = TheClass()
a.theMethod()
"""

ObjectCreatedInParentScopeToMethodReference = """
from b.bah import TheClass
a = TheClass()
def foo():
    a.theMethod()
"""

ObjectCreatedInChildScopeToMethodReference = """
from b.bah import TheClass
a = AnotherClass()
def foo():
    a = TheClass()
a.theMethod()
"""

ObjectCreatedInParentScopeAfterMethodReference = """
class TheClass:
    def theMethod():
        pass

def foo():
    a.theMethod()
a = TheClass()
"""


ObjectCreatedInFunctionAndUsedByCaller = """
class TheClass:
    def theMethod():
        pass
def foo():
    b = TheClass()
    return b
a = foo()
a.theMethod()
"""


ObjectReturnedByFunctionAndUsedByCaller = """
class TheClass:
    def theMethod():
        pass
def foo():
    return TheClass()
a = foo()
a.theMethod()
"""

ObjectReturnedByFunctionAndUsedByCallerInOtherFunction = """
class TheClass:
    def theMethod():
        pass
def bah():
    return TheClass()
def foo():
    a = bah()
    a.theMethod()
"""

ObjectReturnedByFunctionAndUsedByCallerInPreviousFunction = """
class TheClass:
    def theMethod():
        pass
class NotTheClass:
    def theMethod():
        pass

def foo():
    a = bah()
    a.theMethod()

def bah():
    return TheClass()
"""

ObjectRefWithNoDeducableType = """
import blah
class TheClass:
    def theMethod():
        pass

def foo():
    a = blah.foobah()
    a.theMethod()
"""

BasicFunction = """
def foo():
    pass
"""



FunctionWithOneElement = """
import blah
def foo():
    blah.theMethod()
"""

FunctionReturnsArrayExpr = """
import a
class TheClass:
    def theMethod(self):
        pass

def bah():
    return a[35]

b = bah()
b.theMethod()
"""

ClassNestedInFunction = """
def theFunction():
    class TheClass:
        def theMethod(self):
            pass
    a = TheClass()
    a.theMethod()
"""

RefCalledOnClassInstanceCreation = """
class TheClass:
    def theMethod(self): pass
TheClass().theMethod()
"""

MethodRefIsPartOfABiggerCompoundCall = """
class TheClass:
    def theMethod(self): return AnotherClass()
TheClass().theMethod().anotherMethod()
"""


ClassDefWithInheritanceHierarchy = """
from b.bah import DifferentClass
class TheClass(foo.bah):
    def theMethod(self):
        pass
"""

ClassDefWithCompoundInheritanceHierarchy = """
class TheClass(foo.bah):
    def theMethod(self):
        pass
"""



RecursiveFunctionDef = """
class TheClass:
    def theMethod(self):
        pass

def foo(a):
    return foo(a)
"""

FunctionCallReturnsInstance="""
from foo import e
class TheClass:
    def theMethod(self):
        pass
ast = e().f(src)
"""

ClassWithRefToOwnMethod="""
class TheClass:
    def theMethod(self):
        pass
    def anotherMethod(self):
        self.theMethod()
"""

ClassInAClass ="""
class TheClass:
    class AnotherClass:
        pass
    def theMethod(self):
        pass
"""

StreamToStderr = """
def DEBUG(self):
    print >> sys.stderr, "\tfrees:", self.frees

"""



testdata_inheritance ="""
class base:
    pass

class derived(base):
    pass

"""


TheClass = """
class TheClass:
    def theMethod(self):
        pass
    def differentMethod(self):
        pass

class DifferentClass:
    def theMethod(self):
        pass
"""

ClassWithNestedInheritanceSpec = """
import b

class DerivedClass(b.bah.TheClass):
    pass

"""


ClassDerivedFromOtherClassInSameModule = """
class TheClass:
    pass

class DerivedClass(TheClass):
    pass

"""

MethodCalledOnDerivedClassInstance = """
import b

class DerivedClass(b.bah.TheClass):
    pass

class DerivedDerivedClass(DerivedClass):
    pass

theInstance = DerivedDerivedClass()
theInstance.theMethod()
"""

MethodOverriddenOnDerivedClassInstance = """
from b.bah import TheClass as BaseClass

class DerivedClass(BaseClass):
    pass

class DerivedDerivedClass(DerivedClass):
    def theMethod(self):
        print \"hello\"

"""

ClassInstanceIsAttributeOfSelf="""
class TheClass:
    def theMethod(self):
        pass

class AnotherClass:
    def __init__(self):
        self.a = TheClass()
    def anotherFn(self):
        self.a.theMethod()
"""


GetattrWithNoWayToDeduceType ="""
class TheClass:
    def theMethod(self):
        pass
a = TheClass

a.b.bah = 3
"""

ClassHierarchy = """

class root:
    def theMethod():
        pass

class a(root):
    def theMethod():
        pass
    

class b(root):
    pass

class TheClass(b):
    def theMethod():
        pass

ainstance = a()
ainstance.theMethod()

binstance = b1()
binstance.theMethod()

rootinstance = root()
rootinstance.theMethod()

"""

IndirectRecursiveFunctionCall="""
def foo():
    return bah()
    
def bah():
    return baz()

def baz():
    return foo()

a = foo()
"""

RecursiveFunctionCall = """
def get_docstring(self, node, n=None):
    if n is None:
        n = node[0]
        node = node[1:]
    if n == symbol.suite:
        if len(node) == 1:
            return self.get_docstring(node[0])
        for sub in node:
            if sub[0] == symbol.stmt:
                return self.get_docstring(sub)
        return None
    if n == symbol.file_input:
        for sub in node:
            if sub[0] == symbol.stmt:
                return self.get_docstring(sub)
        return None
    if n == symbol.atom:
        if node[0][0] == token.STRING:
            s = ''
            for t in node:
                s = s + eval(t[1])
            return s
        return None
    if n == symbol.stmt or n == symbol.simple_stmt \
       or n == symbol.small_stmt:
        return self.get_docstring(node[0])
    if n in _doc_nodes and len(node) == 1:
        return self.get_docstring(node[0])
    return None
"""

linebreak = """
def foo():
    if foo.bah and \\
       babble:
        pass
"""
linebreak_outputIfTokensMoved = """
def foo():
    if foo.bah and \\
     babble:
        pass
"""

BaseClassNotInAST = """
class TheClass(notInAst):
    def theMethod():
        pass
"""

TheClassOnEndOfNestedExpression = """
class TheClass:
    pass

a.b.c.TheClass    # Shouldn't be renamed
"""
RaiseClassException = """
class TheClass:
    pass

raise TheClass, \"hello mum\"
"""

Function = """
def theFunction():
    pass
"""

FunctionRef = """
import b.bah.theFunction
b.bah.theFunction()
"""

ImportFunctionWithTwoImportsInSameStatement = """
import foo.yadayada, b.bah.theFunction
"""

FunctionRefImportedViaFrom = """
from b.bah import theFunction
theFunction()
"""

theClassAsAFunction = """
def theClass():
    pass
"""

wierdSubclassProblem="""
from b.bah import TheClass, theClass

class DerivedClass(TheClass):
    pass
"""

blankLineBetweenObjCreationAndMethodCall="""
class TheClass:
    def theMethod(self):
        pass

a = myunfindableclass()

a.theMethod()
"""

method_with_NoneAsDefaultArg="""
class TheClass:
    def theMethod(self, root, flist, stack=None):
        pass
"""
function_withPreceedingComment="""
# this is a comment
# this is still a comment
def afunction(foo):
    pass
"""

extract_pass_before="""
class MyClass:
    def myMethod(self):
        pass
"""

extract_pass_after="""
class MyClass:
    def myMethod(self):
        self.newMethod()
    
    def newMethod(self):
        pass
"""

extractPassFromForLoop_before="""
class MyClass:
    def myMethod(self): # comment
        for i in foo:
            pass
"""

extractPassFromForLoop_after="""
class MyClass:
    def myMethod(self): # comment
        for i in foo:
            self.newMethod()

    def newMethod(self):
        pass
"""

extractPassFromForLoop_after2="""
class MyClass:
    def myMethod(self): # comment
        self.newMethod()

    def newMethod(self):
        for i in foo:
            pass        
"""


extractPassFromSingleLineFunction_before="""
class MyClass:
    def myMethod(self): pass # comment
"""

extractPassFromSingleLineFunction_after="""
class MyClass:
    def myMethod(self): self.newMethod() # comment

    def newMethod(self):
        pass    
"""

extractMethodWithSingleTemporaryArg_before="""
class MyClass:
    def myMethod(self): 
        a = something()
        print a
        print \"hello\"
        dosomethingelse(a,b)
"""

extractMethodWithSingleTemporaryArg_after="""
class MyClass:
    def myMethod(self): 
        a = something()
        self.newMethod(a)
        dosomethingelse(a,b)

    def newMethod(self,a):
        print a
        print \"hello\"
"""


extractMethodWithTemporaryArgs_before="""
class MyClass:
    def myMethod(self,c): 
        a = something()
        b = somethingelse()
        print a + b + c + d
        print \"hello\"
        dosomethingelse(a,b)
"""


extractMethodWithTemporaryArgs_after="""
class MyClass:
    def myMethod(self,c): 
        a = something()
        b = somethingelse()
        self.newMethod(a,b,c)
        dosomethingelse(a,b)

    def newMethod(self,a,b,c):
        print a + b + c + d
        print \"hello\"
"""

extractMethodWithSingleReturnValue_before="""
class MyClass:
    def myMethod(self): 
        a = 35    # <-- extract me
        print a
"""

extractMethodWithSingleReturnValue_after="""
class MyClass:
    def myMethod(self):
        a = self.newMethod()
        print a

    def newMethod(self):
        a = 35    # <-- extract me
        return a
"""

extractMethodWithMultipleReturnValues_before="""
class MyClass:
    def myMethod(self): 
        a = 35
        b = 352
        print a + b
"""

extractMethodWithMultipleReturnValues_after="""
class MyClass:
    def myMethod(self):
        a,b = self.newMethod()
        print a + b

    def newMethod(self):
        a = 35
        b = 352
        return a,b
"""

extractMethodWithTupleAssignment_before="""
class MyClass:
    def myMethod(self): 
        a,b,c = 35,36,37
        print a + b
"""

extractMethodWithTupleAssignment_after="""
class MyClass:
    def myMethod(self): 
        a,b,c = 35,36,37
        self.newMethod(a,b)

    def newMethod(self,a,b):
        print a + b
"""

extractCodeAfterDedent_before="""
class MyClass:
    def myMethod(self): # comment
        for i in foo:
            pass
        print \"hello\"
"""

extractCodeAfterDedent_after="""
class MyClass:
    def myMethod(self): # comment
        for i in foo:
            pass
        self.newMethod()        

    def newMethod(self):
        print \"hello\"
"""

extractCodeWithoutNewlines_before="""
class MyClass:
    def myMethod(self): # comment
        for i in foo:
            pass


        
        print \"hello\"
"""

extractCodeWithoutNewlines_after="""
class MyClass:
    def myMethod(self): # comment
        for i in foo:
            pass


        
        self.newMethod()        

    def newMethod(self):
        print \"hello\"
"""

extractPartOfExpression_before="""
class MyClass:
    def myMethod(self): # comment
        a = 32
        b = 2 + a * 1 + 2
"""

extractPartOfExpression_after="""
class MyClass:
    def myMethod(self): # comment
        a = 32
        b = 2 + self.newMethod(a) + 2

    def newMethod(self,a):
        return a * 1
"""


extractFunction_before="""
def myFunction(): # comment
    a = 3
    c = a + 99
    b = c * 1
    print b
"""

extractFunction_after="""
def myFunction(): # comment
    a = 3
    b = newFunction(a)
    print b

def newFunction(a):
    c = a + 99
    b = c * 1
    return b
"""

extractPartOfAssertExpression_before="""
class MyClass:
    def myMethod(self): # comment
        g = 32
        assert output.thingy(g) == \"bah\"
"""

extractPartOfAssertExpression_after="""
class MyClass:
    def myMethod(self): # comment
        g = 32
        assert self.newMethod(g) == \"bah\"

    def newMethod(self,g):
        return output.thingy(g)
"""
